'mdThrowable - by MOD
'2014

'http://docs.oracle.com/javase/6/docs/api/java/lang/Throwable.html


#Ifndef NEWLINE
	#If Defined(__FB_WIN32__)
		#Define NEWLINE !"\r\n"
	#ElseIf Defined(__FB_LINUX__)
		#Define NEWLINE !"\n"
	#EndIf
#EndIf


#Include Once "md/lang/mdObject.bi"
#Include Once "md/lang/mdStackTraceElement.bi"
#Include Once "md/util/mdList.bi"

mdListDeclare(mdStackTraceElement)


#Ifndef __MDTHROWABLE_BI__
#Define __MDTHROWABLE_BI__

Type mdThrowableAlias As mdThrowable

Type mdThrowable Extends mdObject
	Public:
	Declare Constructor ()
	Declare Constructor (ByRef message As String)
	Declare Constructor (ByRef message As String, ByRef cause As mdThrowable)
	Declare Constructor (ByRef cause As mdThrowable)
	Declare Virtual Destructor ()
	
	Declare Virtual Function fillInStackTrace() As mdThrowable
	Declare Virtual Function getCause() As mdThrowable
	Declare Virtual Function getClass() As String
	Declare Virtual Function getLocalizedMessage() As String
	Declare Virtual Function getMessage() As String
	Declare Virtual Function getStackTrace(elements() As mdStackTraceElement) As Boolean
	Declare Virtual Function getStackTrace() As String
	Declare Virtual Function initCause(ByRef cause As mdThrowable) As mdThrowable
	Declare Virtual Sub printStackTrace()
	'Declare Virtual Sub printStackTrace(ByRef s As mdPrintStream)
	'Declare Virtual Sub printStackTrace(ByRef s As mdPrintWriter)
	Declare Virtual Sub setStackTrace(elements() As mdStackTraceElement)
	Declare Virtual Function toString() As String
	
	Declare Virtual Operator Cast() As String
	
	Protected:
	As String detailMessage
	As mdThrowableAlias Ptr cause
	As mdList(mdStackTraceElement) stackTrace
End Type

Constructor mdThrowable()
	'This = This.fillInStackTrace()
	This.cause = @This
End Constructor

Constructor mdThrowable(ByRef message As String)
	'This = This.fillInStackTrace()
	This.detailMessage = message
	This.cause = @This
End Constructor

Constructor mdThrowable(ByRef message As String, ByRef cause As mdThrowable)
	'This = This.fillInStackTrace()
	This.detailMessage = message
	This.cause = @cause
End Constructor

Constructor mdThrowable(ByRef cause As mdThrowable)
	'This = This.fillInStackTrace()
	This.detailMessage = cause.toString()
	This.cause = @cause
End Constructor

Destructor mdThrowable()
	
End Destructor

Function mdThrowable.fillInStackTrace() As mdThrowable
	Return This
End Function

Function mdThrowable.getCause() As mdThrowable
	Return IIf(This.cause = NULL, This, *This.cause)
End Function

Function mdThrowable.getClass() As String
	Return "mdThrowable"
End Function

Function mdThrowable.getLocalizedMessage() As String
	Return This.getMessage()
End Function

Function mdThrowable.getMessage() As String
	Return This.detailMessage
End Function

Function mdThrowable.getStackTrace(elements() As mdStackTraceElement) As Boolean
	stackTrace.toArray(elements())
	Return FALSE
End Function

Function mdThrowable.getStackTrace() As String
	Dim As String ret = This.detailMessage & NEWLINE
	For i As Integer = 0 To stackTrace.size() - 1
		ret &= stackTrace.get(i).toString() & NEWLINE
	Next
	Return ret
End Function

Function mdThrowable.initCause(ByRef cause As mdThrowable) As mdThrowable
	This.cause = @cause
	Return This
End Function

Sub mdThrowable.printStackTrace()
	Print This.getStackTrace()
End Sub

'Sub mdThrowable.printStackTrace(ByRef s As mdPrintStream)

'Sub mdThrowable.printStackTrace(ByRef s As mdPrintWriter)

Sub mdThrowable.setStackTrace(elements() As mdStackTraceElement)
	stackTrace.clear()
	For i As Integer = LBound(elements) To UBound(elements)
		stackTrace.add(elements(i))
	Next
End Sub

Function mdThrowable.toString() As String
	Dim As String ret
	Dim As String message = This.getLocalizedMessage()
	If message <> "" Then
		ret = "mdThrowable: " & message
	EndIf
	Return ret
End Function

Operator mdThrowable.Cast() As String
	Return This.toString()
End Operator

Operator = (ByRef lhs As mdThrowable, ByRef rhs As mdThrowable) As Integer
	Return Str(lhs) = Str(rhs)
End Operator

#EndIf '__MDTHROWABLE_BI__
