'mdLevel - by MOD
'2014

'http://docs.oracle.com/javase/6/docs/api/java/util/logging/Level.html


Type mdLevelAlias As mdLevel


#Include Once "md/lang/mdObject.bi"
#Include Once "md/util/mdResourceBundle.bi"
#Include Once "md/util/mdList.bi"

mdListDeclare(mdLevelAlias, Ptr)


#Ifndef __MDLEVEL_BI__
#Define __MDLEVEL_BI__

Type mdLevel Extends mdObject
	Public:
	'Declare Virtual Function equals(ByRef ox As mdObject) As Boolean
	Declare Virtual Function equals(ByRef ox As mdLevel) As Boolean
	Declare Virtual Function getClass() As String
	Declare Virtual Function getLocalizedName() As String
	Declare Virtual Function getName() As String
	Declare Virtual Function getResourceBundleName() As String
	Declare Virtual Function hashCode() As Integer
	Declare Virtual Function intValue() As Integer
	Declare Static Function parse(ByRef name_ As String) As mdLevel
	Declare Virtual Function toString() As String
	
	'Protected:
	Declare Constructor ()
	Declare Constructor (ByRef name_ As String, ByVal value As Integer)
	Declare Constructor (ByRef name_ As String, ByVal value As Integer, ByRef resourceBundleName As String)
	
	Protected:
	As Integer logLevel
	As String logName
	As String resourceBundleName
	
	Static As mdList(mdLevelAlias, Ptr) known
	Static As String defaultBundle
	
	Public:
	Static As /'Const'/ mdLevel ALL
	Static As /'Const'/ mdLevel FINEST
	Static As /'Const'/ mdLevel FINER
	Static As /'Const'/ mdLevel FINE
	Static As /'Const'/ mdLevel CONFIG
	Static As /'Const'/ mdLevel INFO
	Static As /'Const'/ mdLevel WARNING
	Static As /'Const'/ mdLevel SEVERE
	Static As /'Const'/ mdLevel OFF
End Type

Dim As mdList(mdLevelAlias, Ptr) mdLevel.known
Dim As String mdLevel.defaultBundle

Dim As /'Const'/ mdLevel mdLevel.ALL = mdLevel("ALL", 0, "")
Dim As /'Const'/ mdLevel mdLevel.FINEST = mdLevel("FINEST", 300, "")
Dim As /'Const'/ mdLevel mdLevel.FINER = mdLevel("FINER", 400, "")
Dim As /'Const'/ mdLevel mdLevel.FINE = mdLevel("FINE", 500, "")
Dim As /'Const'/ mdLevel mdLevel.CONFIG = mdLevel("CONFIG", 700, "")
Dim As /'Const'/ mdLevel mdLevel.INFO = mdLevel("INFO", 800, "")
Dim As /'Const'/ mdLevel mdLevel.WARNING = mdLevel("WARNING", 900, "")
Dim As /'Const'/ mdLevel mdLevel.SEVERE = mdLevel("SEVERE", 1000, "")
Dim As /'Const'/ mdLevel mdLevel.OFF = mdLevel("OFF", &h0FFFFFFF, "")

Constructor mdLevel()
	mdLevel.defaultBundle = "md.util.logging.resources.logging"
End Constructor

Constructor mdLevel(ByRef name_ As String, ByVal value As Integer)
	This.Constructor(name_, value, "")
End Constructor

Constructor mdLevel(ByRef name_ As String, ByVal value As Integer, ByRef resourceBundleName As String)
	mdLevel.defaultBundle = "md.util.logging.resources.logging"
	This.logName = name_
	This.logLevel = value
	This.resourceBundleName = resourceBundleName
	known.add(@This)
End Constructor

'Function mdLevel.equals(ByRef ox As mdObject) As Boolean

Function mdLevel.equals(ByRef ox As mdLevel) As Boolean
	Return This.intValue() = ox.intValue()
End Function

Function mdLevel.getClass() As String
	Return "mdLevel"
End Function

Function mdLevel.getLocalizedName() As String
	If This.resourceBundleName <> "" Then
		Dim As mdResourceBundle rb = mdResourceBundle.getBundle(This.resourceBundleName)
		Return rb.getString(This.logName)
	EndIf
	Return This.logName
End Function

Function mdLevel.getName() As String
	Return This.logName
End Function

Function mdLevel.getResourceBundleName() As String
	Return This.resourceBundleName
End Function

Function mdLevel.hashCode() As Integer
	Return Cast(Integer, @This)
End Function

Function mdLevel.intValue() As Integer
	Return This.logLevel
End Function

Function mdLevel.parse(ByRef name_ As String) As mdLevel
	If name_ = "" Then
		Return mdLevel.SEVERE
	EndIf
	For i As Integer = 0 To known.size() - 1
		Dim As mdLevel Ptr level = known.get(i)
		If name_ = level->getLocalizedName() OrElse name_ = level->getName() Then
			Return *level
		EndIf
	Next
	
	Dim As Integer x = ValInt(name_)
	For i As Integer = 0 To known.size() - 1
		Dim As mdLevel Ptr level = known.get(i)
		If x = level->intValue() Then
			Return *level
		EndIf
	Next
	Return mdLevel(name_, x)
End Function

Function mdLevel.toString() As String
	Return This.logName
End Function

Operator = (ByRef lhs As mdLevel, ByRef rhs As mdLevel) As Integer
	Return lhs.equals(rhs)
End Operator

#EndIf '__MDLEVEL_BI__
